=== debian/changelog ===
libopenshot (0.2.7+dfsg1-4) unstable; urgency=medium

  [ Stephan Lachnit ]
  * [82bb3f0] zmq.hpp now in cppzmq-dev. Update dependency. (Closes: #1020020)

  [ Anton Gladky ]
  * [425ba77] Update watch file format version to 4.

 -- Anton Gladky <gladk@debian.org>  Wed, 21 Sep 2022 06:54:10 +0200

libopenshot (0.2.7+dfsg1-3) unstable; urgency=medium

  * Team upload
  * debian/patches: Apply upstream patches to fix FTBFS with ffmpeg 5.0
    (Closes: #1004763)
  * debian/control: Bump Standards-VVersion

 -- Sebastian Ramacher <sramacher@debian.org>  Sun, 31 Jul 2022 11:13:56 +0200

libopenshot (0.2.7+dfsg1-2) unstable; urgency=medium

  * Team upload
  * Upload to unstable

 -- Sebastian Ramacher <sramacher@debian.org>  Sun, 06 Mar 2022 20:39:17 +0100

libopenshot (0.2.7+dfsg1-1) experimental; urgency=medium

  * Team upload
  * New upstream version 0.2.7+dfsg1
  * SONAME bump: libopenshot19 -> libopenshot21
  * debian/control:
    - Add BD on libasound2-dev
    - Bump libopenshot-audio-dev BD
  * debian/patches:
    - Remove old patches
    - Include SOVERSION in VERSION
  * debian/copyright: Update copyright years and information
  * debian/rules:
    - Remove unused -DLIB_SUFFIX
    - No longer specify -Wl,--as-needed

 -- Sebastian Ramacher <sramacher@debian.org>  Sat, 05 Mar 2022 15:35:00 +0100

libopenshot (0.2.5+dfsg1-6) unstable; urgency=medium

  * Team upload

  [ Gianfranco Costamagna ]
  * debian/patches/698.patch:
    - cherry-pick a rebase of an upstream patch for FFMPEG 4.4-6
      test failure (Closes: #994205)
      - thanks Nicola Ferralis for the help and patch!

  [ Sebastian Ramacher ]
  * debian/control: Bump Standards-Version

 -- Sebastian Ramacher <sramacher@debian.org>  Wed, 13 Oct 2021 22:01:31 +0200

libopenshot (0.2.5+dfsg1-5) unstable; urgency=medium

  * Team upload
  * debian/control:
    - Switch to libswresample-dev (Closes: #971327)
    - Bump Standards-Version

 -- Sebastian Ramacher <sramacher@debian.org>  Mon, 16 Aug 2021 09:45:01 +0200

libopenshot (0.2.5+dfsg1-4) unstable; urgency=medium

  * [2131f12] Fix FTBFS due to gcc-10 and ffmpeg. (Closes: #967016)

 -- Anton Gladky <gladk@debian.org>  Thu, 13 Aug 2020 22:49:03 +0200

libopenshot (0.2.5+dfsg1-3) unstable; urgency=medium

  * [72291de] Trim trailing whitespace.
  * [43689f7] Add d/not-installed. (Closes: #964666)

 -- Anton Gladky <gladk@debian.org>  Wed, 15 Jul 2020 20:46:25 +0200
