=== debian/control ===
Source: libopenshot
Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
Uploaders: Dr. Tobias Quathamer <toddy@debian.org>,
           Anton Gladky <gladk@debian.org>
Section: libs
Rules-Requires-Root: no
Priority: optional
Build-Depends: cmake,
               debhelper-compat (= 13),
               dh-python,
               ffmpeg,
               libasound2-dev,
               libavcodec-dev,
               libavdevice-dev,
               libavformat-dev,
               libavutil-dev,
               libjsoncpp-dev,
               libmagick++-6.q16-dev,
               libopenshot-audio-dev (>= 0.2.2),
               libswresample-dev,
               libswscale-dev,
               libunittest++-dev,
               cppzmq-dev,
               pkg-config,
               python3-dev,
               qtbase5-dev,
               qtmultimedia5-dev,
               swig
Build-Depends-Indep: doxygen <!nodoc>
Standards-Version: 4.6.1
Vcs-Browser: https://salsa.debian.org/multimedia-team/libopenshot
Vcs-Git: https://salsa.debian.org/multimedia-team/libopenshot.git
Homepage: https://www.openshot.org/

Package: libopenshot-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: ${misc:Depends},
         libopenshot21 (= ${binary:Version})
Suggests: libopenshot-doc <!nodoc>
Description: development files for the OpenShot video library
 OpenShot Library (libopenshot) is an open-source project dedicated to
 delivering high quality video editing, animation, and playback solutions
 to the world. The API currently supports C++, Python, and Ruby.
 .
 This package provides the development files.

Package: libopenshot21
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: library for high-quality video editing
 OpenShot Library (libopenshot) is an open-source project dedicated to
 delivering high quality video editing, animation, and playback solutions
 to the world. The API currently supports C++, Python, and Ruby.
 .
 This package provides the shared libraries.

Package: libopenshot-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: ${misc:Depends}
Description: documentation for the OpenShot video library
 OpenShot Library (libopenshot) is an open-source project dedicated to
 delivering high quality video editing, animation, and playback solutions
 to the world. The API currently supports C++, Python, and Ruby.
 .
 This package provides the documentation.
Build-Profiles: <!nodoc>

Package: python3-openshot
Architecture: any
Section: python
Depends: ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends}
Description: OpenShot video library bindings for Python 3
 OpenShot Library (libopenshot) is an open-source project dedicated to
 delivering high quality video editing, animation, and playback solutions
 to the world. The API currently supports C++, Python, and Ruby.
 .
 This package provides the bindings for Python 3.
